// Для работы скрипта необходимо:
// - фишинг, магери, удочка, галеон
// - рунбука с руной в банк с названием 'home'
// - лрк сет
// - руна на корабль
// Для настройки необходимо
// - указать серийник удочки, это можно сделать через вкладку World, найдя там свою удочку в списке, либо через запуск клиента через стелс и командой info
// - указать серийник руны на корабль, это можно сделать через вкладку World, найдя там свою руну в списке, либо через запуск клиента через стелс и командой info
// - указать серийник контейнера банка, это можно сделать только через вкладку World, открыв банк и найдя в списке сундук
// - корабль в скрипте плывет по прямой и обратно, поэтому необходимо заранее вывести его на траекторию, где он гарантированно не врежется

Program BankFisher;
const
pole = $4002F85F;
rune = $4001CF2E;
bank = $401724FC;
home_book_name = 'home';
weight_threshold = 20;
max_steps = 50;

book_type = $22C5;
book_gump = $554B87F3;

var
start: TDateTime;
i: Integer;
fish: Array of Cardinal;
steps: Integer;
home_book: Cardinal;
SL: TStringList;
junk: Array of Cardinal;
x, y: Integer;

procedure CheckConnection;
begin
  if not Connected then begin
    while not Connected do begin
      AddToSystemJournal('Reconnecting...');
      wait(10000);
      Connect;
    end;
  end;
end;


procedure CloseGump(id: Cardinal);
var
i:Integer;
begin
  for i := 0 to GetGUmpsCount - 1 do begin
    if GetGumpID(i) = id then begin
      CloseSimpleGUmp(i);
      Wait(500);
      break;
    end;
  end;
end;

function WaitForGump(id:Cardinal): Integer;
var
attempts, i: Integer;
begin

  for attempts := 0 to 15 do begin
    AddToSystemJournal('Ждем гамп...');
    wait(200);
    for i := 0 to GetGUmpsCount - 1 do begin
      if GetGumpID(i) = id then begin
        Result := i;
        Exit;
      end;
    end;
  end;
  Result := -1;
  AddToSystemJournal('Гамп ' + IntTOStr(id) + ' не найден!');
end;


procedure ReplyGump(id, btn: Cardinal);
var
i:Integer;
begin
  for i := 0 to GetGUmpsCount - 1 do begin
    if GetGumpID(i) = id then begin
      if NumGumpButton(i, btn) then begin
        Wait(500);
        break;
      end;
    end;
  end;
end;

function HasProperty(item:Cardinal; prop: String):boolean;
var
tooltip: String;
i:Integer;
begin
  SL := TStringList.Create;
  tooltip := GetTooltip(item);

  StrBreakApart(tooltip, '|', SL);
  Result := false;
  for i := 0 to Sl.Count -1 do begin
    if(BMSearch(0, Sl.Strings[i], prop) <> 0) then begin
      Result := true;
      break;
    end;
  end;
  SL.Free;
end;

procedure SetupBooks();
var
id: Cardinal;
List: TStringList;
i:Integer;
begin
  List := TStringList.Create;
  FIndType(book_type, Backpack);
  GetFIndedList(List);
  for i := 0 to List.Count - 1 do begin
    id := StrToInt('$'+List[i]);
    if(HasProperty(id, home_book_name)) then begin
      home_book := id;
    end;
  end;
  if(home_book = -1) then begin
    AddToSystemJournal('Нет рунбуки домой!');
  end else begin
    AddToSystemJournal('Рунбука домой есть');
  end;
end;


function Recall(b:Cardinal; r: Integer; ByScroll: boolean):Byte;
var
x, y : Word;
i: Integer;
msgBlocked, msgRecharge, msgRecovered, msgYouMustWait, msgConcentration, msgOverWeigth, msgFAILS, msgALL: String;
cTime: TDateTime;
begin
  CheckConnection;

  msgRecharge      := 'This book needs time to recharge.';
  msgYouMustWait   := 'You must wait to perform another action.';
  msgBlocked       := 'That location is blocked.';
  msgRecovered     := 'You have not yet recovered from casting a spell.';
  msgConcentration := 'Your concentration is disturbed, thus ruining thy spell.';
  msgOverWeigth    := 'Thou art too encumbered to move.';
  msgFAILS := msgRecharge + '|' + msgYouMustWait + '|' + msgRecovered + '|' + 'reagents';
  AddToSystemJournal('Телепортация...');

  cTime := Now;
  UseObject(b);
  wait(500);

  Step(1, true);
  WaitForGump(book_gump);

  x := GetX(SelfID);
  y := GetY(SelfID);

  if(ByScroll) then begin
    ReplyGump(book_gump, 6 * r + 2);
  end else begin
    ReplyGump(book_gump, 6 * r + 5);
  end;
  wait(500);
  for i := 0 to 6 do begin
    AddToSystemJournal('Проверка телепортации...');
    CheckConnection;
    wait(500);
    if(InJournalBetweenTimes(msgFAILS, cTime, Now) <> -1) then begin result := 1; break; end;
    if(InJournalBetweenTimes(msgBlocked, cTime, Now) <> -1) then begin result := 2; break; end;

    if (((GetX(SelfID) <> x) or (GetY(SelfID) <> y))) then begin
      AddToSystemJournal('Телепорт удачный');
      Result := 0;
      Exit;
    end;
  end;
  AddToSystemJournal('Телепорт НЕудачный');
end;

function FishResult(): Boolean;
var
msg: String;
cTime : TDateTime;
begin
  msg := 'biting | fail | pull out';
  cTime := Now;
  for i := 0 to 100 do
  begin
    CheckConnection;
    Wait(100);
    if (InJournalBetweenTimes(msg, cTime, Now) <> -1) then begin result := true; exit; end;
  end;
end;

procedure CheckJunk();
var
id: Cardinal;
List: TStringList;
i, j:Integer;
begin
  for j := 0 to High(junk) do begin
    CheckCOnnection;

    List := TStringList.Create;
    FIndType(junk[j], Backpack);
    GetFIndedList(List);
    for i := 0 to List.Count - 1 do begin
      id := StrToInt('$'+List[i]);
      UOSay('gotcha!');
      MoveItem(id, 1, Ground, GetX(Self) - 1, GetY(Self), GetZ(Self));
      wait(800);

    end;
    wait(1000);
  end;
end;

procedure CheckBigFish();
var
id: Cardinal;
List: TStringList;
i:Integer;
begin
  List := TStringList.Create;
  FIndType($09CC, Backpack);
  GetFIndedList(List);
  for i := 0 to List.Count - 1 do begin
    CheckCOnnection;
    id := StrToInt('$'+List[i]);
    if((GetColor(id) = $0847) OR (GetColor(id) = $058C )) then begin
      UOSay('gotcha!');
      MoveItem(id, 1, Ground, GetX(Self) - 1, GetY(Self), GetZ(Self));
      wait(800);
    end;
  end;
  wait(1000);

end;

procedure CheckStuck();
begin
  if(InJournal('stopped') <> -1) then begin
    clearjournal;
    UOSay('turn around');
  end;
end;

function HasResources():Boolean;
var
i:Integer;
begin
  for i := 0 to Length(fish) -1 do begin
    if(FIndType(fish[i], Backpack) <> 0) then begin
      Result := true;
      Exit
    end;
  end;
  Result := false;
end;

function Overloaded(): BOolean;
begin
  Result := (Weight > MaxWeight - weight_threshold);
end;

begin
  home_book := -1;
  junk := [$1711, $170B, $170F, $0DD6, $170D];
  CheckBigFish();
  CheckJunk();
  wait(1000);
  x := GetX(Self);
  y := GetY(Self);
  while((GetX(Self)= x) AND (GetY(Self) = y)) do begin
    Cast('Recall');
    WaitForTarget(3000);
    TargetToObject(rune);
    wait(1500);
  end;
  Step(0, false);
  Step(0, false);
  SetupBooks();
  fish := [$44C6,  $4303, $09CC, $09CD, $09CF, $09CE, $44C3, $44C4, $09CF, $4306, $4302, $4307, $4302, $573A, $3196, $44C5];
  while(true) do begin
    CheckCOnnection;
    if(Overloaded) then begin
      CheckJunk();
      CheckBigFish();
      while(not (Recall(home_book, 0, false) = 0)) do begin
      end;
      wait(1000);
      UOSay('bank');
      for i := 0 to High(fish) do begin
        CheckCOnnection;
        while(FindType(fish[i], Backpack) <> 0) do begin
          MoveItem(finditem, FindQuantity(), bank, 0,0,0);
          wait(350);
        end;
      end;
      wait(1000);
      x := GetX(Self);
      y := GetY(Self);
      while((GetX(Self)= x) AND (GetY(Self) = y)) do begin
        Cast('Recall');
        WaitForTarget(3000);
        TargetToObject(rune);
        wait(1500);
      end;
      Step(0, false);
      Step(0, false);
    end else begin
      wait(100);
      UseObject(pole);
      WaitForTarget(3000);
      TargetToXYZ(GetX(Self) + 2, GetY(Self), GetZ(Self));
      start := Now;
      while(not FishResult) do begin end;
      if(InJournalBetweenTimes('biting', start, Now) <> -1) then begin
        CheckCOnnection;
        for i := 0 to 8 do begin
          UOSay('one forward');
          wait(750);
        end;
        steps := steps + 1;
        if(steps > max_steps) then begin
          UOSay('turn around');
          steps := 0;
        end;
      end;
      CheckStuck();
    end;
  end;
end.