Program RemoveTrap;
const
//нужен Circuit trap и все
//Серийник трап кита
kit = $43B57A23;

//DO NOT TOUCH
gump    = $2710;
upID    = 1;
downID  = 3;
rightID = 2;
leftID  = 4;
failtMsg   = 'You fail to disarm the trap and reset it.';
successMsg = 'You successfully disarm the trap!';
top   = 0;
right = 1;
bot   = 2;
left  = 3;
gemID = 9720;

type
TArr = Array of byte;

var
directions, ignored, moves: Array of byte;
passed: Array of Array of boolean;
solving, failed, bordersGet: Boolean;
posX, posY, lastDirection, LeftBorder, TopBorder, RightBorder, BotBorder, i: byte;
lastMove: Cardinal;

procedure CheckConnection;
begin
  if not Connected then begin
    while not Connected do begin
      AddToSystemJournal('Переподключение...');
      wait(10000);
      Connect;
    end;
  end;
end;

procedure ReplyGump( btn: Cardinal);
var
i:Integer;
begin
  for i := 0 to GetGUmpsCount - 1 do begin
    if GetGumpID(i) = gump then begin
      if NumGumpButton(i, btn) then begin
        Wait(900);
        break;
      end;
    end;
  end;
end;

function PassedTile(direction:byte):Boolean;
var
i, x_off, y_off:integer;
begin
  if(direction = top) then begin
    x_off := 0;
    y_off := -1;
  end;
  if(direction = bot) then begin
    x_off := 0;
    y_off := 1;
  end;
  if(direction = left) then begin
    x_off := -1;
    y_off := 0;
  end;
  if(direction = right) then begin
    x_off := 1;
    y_off := 0;
  end;
  if((posX + x_off >= 0) and (posX + x_off <= RightBorder) and (posY + y_off >= 0) and (posY + y_off <= RightBorder)) then begin
    Result := passed[posX + x_off][posY + y_off];
  end else begin
    Result := true;
  end;
end;

function IgnoredDirection(direction:byte):Boolean;
var
i:integer;
begin
  for i := 0 to High(ignored) do begin
    if(ignored[i] = direction) then begin
      Result := true;
      exit;
    end;
  end;
  Result := false;
end;

procedure GetDirections(var ad: Array of byte);
begin
  SetLength(ad, 0);
  if((posX > LeftBorder) and not IgnoredDirection(left) and not PassedTile(left)) then begin
    SetLength(ad, Length(ad) + 1);
    ad[High(ad)] := left;
  end;
  if((posX < RightBorder) and not IgnoredDirection(right) and not PassedTile(right)) then begin
    SetLength(ad, Length(ad) + 1);
    ad[High(ad)] := right;
  end;
  if((posY < BotBorder) and not IgnoredDirection(bot) and not PassedTile(bot)) then begin
    SetLength(ad, Length(ad) + 1);
    ad[High(ad)] := bot;
  end;
  if((posY > TopBorder) and not IgnoredDirection(top) and not PassedTile(top)) then begin
    SetLength(ad, Length(ad) + 1);
    ad[High(ad)] := top;
  end;
end;

procedure FixBorders;
var
i, g_index:Integer;
gi: TGumpInfo;
amt: byte;
begin
  amt := 0;
  for i := 0 to GetGUmpsCount - 1 do begin
    if GetGumpID(i) = gump then begin
      g_index := i;
      break;
    end;
  end;
  if(g_index <> -1) then begin
    GetGumpInfo(g_index, gi);
    for i := Low(gi.GumpPics) to High(gi.GumpPics) do begin
      if(gi.GumpPics[i].Id = gemID) then begin
        amt := amt + 1;
      end;
    end;
  end;
  if(amt <= 9) then begin
    RightBorder := 2;
    BotBorder := 2;
  end else if ( amt <= 14 ) then begin
    RightBorder := 3;
    BotBorder := 3;
  end else if ( amt <= 23 ) then begin
    RightBorder := 4;
    BotBorder := 4;
  end;
end;

procedure FillPassed(x,y:byte);
begin
  passed[x][y] := true;
end;

procedure Move(direction: byte);
begin
  AddToSystemJournal('Moving: ' + IntToStr(direction));

  if(direction = bot) then
  posY := posY + 1;

  if(direction = top) then
  posY := posY - 1;

  if(direction = left) then
  posX := posX - 1;

  if(direction = right) then
  posX := posX + 1;

  FillPassed(posX, posY);

  lastMove := GetTickCount;

  ReplyGump(moves[direction]);
end;

procedure InitPassedField();
var
i, j :Integer;
begin
  SetLength(passed, RightBorder + 1);
  for i := 0 to Length(passed) - 1 do begin
    SetLength(passed[i], RightBorder + 1);
    for j := 0 to High(passed[i]) do begin
      passed[i][j] := false;
    end;
  end;
  passed[0][0] := true;
end;



procedure GumpIncoming(Serial,GumpID,X,Y:Cardinal);
var
allowedDirections: Array of byte;
begin
  if(GumpID = gump) then begin
    if ( not bordersGet ) then begin
      FixBorders;
      InitPassedField;
      bordersGet := true;
    end;
    if(not failed) then begin //we are started
      if(Length(ignored) > 0) then
      SetLength(ignored, 0);

      GetDirections(allowedDirections);
      if(Length(allowedDirections) = 0) then begin
        if(Length(ignored) > 0) then
        SetLength(ignored, 0);
        GetDirections(allowedDirections);
      end;
      lastDirection := allowedDirections[0];
      SetLength(directions, Length(directions) + 1);
      directions[High(directions)] := lastDirection;

      Move(lastDirection);
    end else begin //we are failed
      if((i <= High(directions)) and (Length(directions) > 0)) then begin
        lastDirection := directions[i];
        i := i + 1;
        Move(lastDirection);
      end else begin
        i := 0;
        failed := false;

        GetDirections(allowedDirections);
        if(Length(allowedDirections) = 0) then begin
          if(Length(ignored) > 0) then
          SetLength(ignored, 0);
          GetDirections(allowedDirections);
        end;
        lastDirection := allowedDirections[0];

        SetLength(directions, Length(directions) + 1);
        directions[High(directions)] := lastDirection;

        Move(lastDirection);
      end;
    end;
  end;
end;

function HasNoGump(): Boolean;
var
i:Integer;
begin
  for i := 0 to GetGUmpsCount - 1 do begin
    if GetGumpID(i) = gump then begin
      RESULT := false;
      EXIT;
    end;
  end;
  RESULT := true;
end;

procedure CloseGump(id: Cardinal);
var
i:Integer;
begin
  for i := 0 to GetGUmpsCount - 1 do begin
    if GetGumpID(i) = id then begin
      CloseSimpleGUmp(i);
      Wait(500);
      break;
    end;
  end;
end;

begin
  moves := [upID, rightID, downID, leftID];
  SetEventProc(evIncomingGump, 'GumpIncoming');
  solving := false;
  failed := false;
  LeftBorder := 0;
  TopBorder := 0;
  while(true) do begin
    CheckConnection;
    if( not solving or failed or HasNoGump) then begin
      solving := true;
      UseSkill('Remove Trap');
      WaitForTarget(2000);
      TargetToObject(kit);
    end;
    if(InJournal(failtMsg) <> -1) then begin
      i := 0;
      posX := 0;
      posY := 0;
      SetLength(ignored, Length(ignored) + 1); //resetting path
      ignored[High(ignored)] := lastDirection;
      SetLength(directions, Length(directions) - 1); //removing last move
      failed := true;
      ClearJournal;
      InitPassedField();
    end;
    if(InJournal(successMsg) <> -1) then begin
      failed := false;
      solving := false;
      SetLength(directions, 0); //resetting path
      SetLength(ignored, 0); //resetting ignored
      posX := 0;
      posY := 0;
      bordersGet := false;
      ClearJournal;
    end;
    if(GetTickCount - lastMove >= 5000) then begin
      CloseGump(gump);
      lastMove := GetTickCount;
    end;
    Wait(100);
  end;
end.