// Для работы скрипта необходимо:
// - Lumberjacking
// - дом около деревьев для отгрузки ресурсов на входе
// Для настройки необходимо
// - указать путь к файлам игры для работы поиска деревьев
// - указать серийник топора, это можно сделать через вкладку World, найдя там свой топор в списке, либо через запуск клиента через стелс и командой info
// - указать серийник контейнера для ресурсов, это можно сделать через вкладку World, найдя там свой контейнер в списке, либо через запуск клиента через стелс и командой info
// - после запуска скрипта, бот потратит некоторое время на сканирование карты на наличие деревьев и пойдет копать
// - чтобы изменить радиус сканирования, поменяйте значение переменной SeekRange на 19 строчке.
Program SpotLumber;
const
prod_container = $40EC50AC;
axe_id = $42518839;
home_x = 461;
home_y = 3649;

//misc
weight_threshold = 50;
SeekRange = 150;

//items
book_type = $22C5;

type
MinTile = record
x, y, z, Tile : Word;
end;

var
state:Byte;//0 - initial, 1 - harvest, 2 - unload/smelt
books: Array of Cardinal;
books_runes: Array of Integer;
home: Cardinal;
book: Integer;
rune: Integer;
SL : TStringList;
MinTiles_Array : Array of MinTile;
Resources, Trees: Array of Word;
mine_index: Integer;
hidden: boolean;
               
walking: BOolean;
p : TPathArray;
target_x, target_y: Integer;
target: Cardinal;

procedure GoHome();
begin
  NewMoveXY(home_x, home_y, true, 1, true);
  state := 2;
end;

function WaitForGump(id:Cardinal): Integer;
var
attempts, i: Integer;
begin
  for attempts := 0 to 15 do begin
    wait(200);
    for i := 0 to GetGUmpsCount - 1 do begin
      if GetGumpID(i) = id then begin
        Result := i;
        Exit;
      end;
    end;
  end;
  Result := -1;
  AddToSystemJournal('Gump ' + IntTOStr(id) + ' not found!');
end;


procedure ReplyGump(id, btn: Cardinal);
var
i:Integer;
begin
  for i := 0 to GetGUmpsCount - 1 do begin
    if GetGumpID(i) = id then begin
      if NumGumpButton(i, btn) then begin
        Wait(500);
        break;
      end;
    end;
  end;
end;

procedure CheckConnection;
begin
  if not Connected then begin
    while not Connected do begin 
      AddToSystemJournal('Reconnecting...');
      wait(10000);
      Connect;
    end;
  end;
end;

function Overloaded(): BOolean;
begin
  Result := (Weight > MaxWeight - weight_threshold);
end;

function MinTileSpot(Idx : Integer) : Integer;
var
i, k : Integer;
msgFizzle, msgEnd, msgAttack, msgSuccess : String;
cTime : TDateTime;

begin
  msgFizzle := 'hack at the tree ';
  msgEnd := 'not enough | seen';      
  msgAttack := 'is attacking you';
  msgSuccess := 'chop some';

  result := 0;

  if Dist(GetX(self), GetY(self), MinTiles_Array[Idx].x, MinTiles_Array[Idx].y) > 1 then
  NewMoveXY(MinTiles_Array[Idx].x, MinTiles_Array[Idx].y, true, 1, true);

  for k := 0 to 7 do
  begin 
    CheckConnection;

    if (ObjAtLayerEx(LhandLayer,self) = 0) then begin
      AddToSystemJournal('There is no axe equipped!');
      result := 1;
      exit;
    end;

    UseObject(axe_id);


    if not WaitForTarget(10000) then
    begin
      AddToSystemJournal('There is no target for a long time (probably we lose an axe).');
      result := 1;
      exit;
    end
    else
    begin
      cTime := Now;
      TargetToTile(MinTiles_Array[Idx].Tile, MinTiles_Array[Idx].x, MinTiles_Array[Idx].y, MinTiles_Array[Idx].z);
      for i := 0 to 100 do
      begin
        CheckConnection;
        Wait(100);
        if (InJournalBetweenTimes(msgAttack, cTime, Now) <> -1) then begin result := 2; exit; end;
        if (InJournalBetweenTimes(msgEnd + '|far away', cTime, Now) <> -1) then  begin result := 3; exit; end;

        if (InJournalBetweenTimes(msgFizzle, cTime, Now) <> -1) then break;
        if (InJournalBetweenTimes(msgSuccess, cTime, Now) <> -1) then break;
        if ( Overloaded() ) then begin
          result := 2;
          exit;
        end;
      end;
    end;
  end;
end;

function isTree(id:Word):Boolean;
var
i:Integer;
begin
  for i := 0 to Length(Trees) -1 do begin
    if((Trees[i] - 16384) = id) then begin
      Result := true;
      Exit;
    end;
  end;
  Result := false;
end;

procedure GetTilesToMine;
var
x, y, i, k : Integer;
TileInfo : TStaticCell;
begin
  k := 1;
  for x := (-1 * SeekRange) to SeekRange do
  for y := (-1 * SeekRange) to SeekRange do
  begin
    TileInfo := ReadStaticsXY(GetX(self)+x, GetY(self)+y, WorldNum);
    if TileInfo.StaticCount > 0 then
    for i := Low(TileInfo.Statics) to High(TileInfo.Statics) do
    if (isTree(TileInfo.Statics[i].Tile)) then
    begin        
      SetLength(MinTiles_Array, k + 1);
      MinTiles_Array[k].Tile := TileInfo.Statics[i].Tile;
      MinTiles_Array[k].x := TileInfo.Statics[i].x;
      MinTiles_Array[k].y := TileInfo.Statics[i].y;
      MinTiles_Array[k].z := TileInfo.Statics[i].z;  
      inc(k);  
    end;  
      
  end;

  AddToSystemJournal('Found ' + IntToStr(Length(MinTiles_Array)) + ' trees for lumberjacking.');
end;

procedure TryHarvest;
var
MineResult: Integer;
begin
  CheckConnection;
  if(not Overloaded()) then begin
    if(Length(MinTiles_Array) > 0) then begin
     
        AddToSystemJournal('Harvesting...');

        if(mine_index + 1 < Length(MinTiles_Array) - 1) then begin
          mine_index := mine_index + 1;
        end else begin
          mine_index := 0;
        end;  
        
        CheckConnection;
        MineResult := MinTileSpot(mine_index);    
        
        if MineResult = 1 then begin
          AddToSystemJournal('Next!');
          GoHome;
          state := 2;
        end; 
        
        if MineResult = 2 then begin
          AddToSystemJournal('Attacked!');
          GoHome;
          state := 2;
        end;    
        
        if MineResult = 3 then begin
          AddToSystemJournal('Next!');
        end;         
        
    end else begin
        mine_index := 0;
    end;
  end else begin
    AddToSystemJournal('Overloaded!!');
    GoHome;
    state := 2;
  end;
end;

function HasResources():Boolean;
var
i:Integer;
begin
  for i := 0 to Length(Resources) -1 do begin
    if(FIndType(Resources[i], Backpack) <> 0) then begin
      Result := true;
      Exit
    end;
  end;
  Result := false;
end;

procedure TryConvert;
var
found:Cardinal;
i:Integer;
begin
  if(GetDistance(prod_container) > 2) then begin
      NewMoveXY(GetX(prod_container), GetY(prod_container), true, 1, true);
  end;
  if(HasResources()) then begin
    for i := 0 to Length(Resources) -1 do begin
      if(FIndType(Resources[i], Backpack) <> 0) then begin
        found := finditem;
        break;
      end;
    end;
    MoveItem(found, findquantity, prod_container, 0,0,0);
    wait(500);
  end else begin
    state := 0;
  end;
end;

begin
  Resources := [$1BDD, $3190, $2f5f, $3191, $318f, $3199, $5738 ];
  Trees := [$4CCA, $4CCB, $4CCC, $4CCD, $4CD0, $4CD3, $4CD6, $4CD8,
  $4CDA, $4CDD, $4CE0, $4CE3, $4CE6, $4CF8, $4CFB, $4CFE,
  $4D01, $4D41, $4D42, $4D43, $4D44, $4D57, $4D58, $4D59,
  $4D5A, $4D5B, $4D6E, $4D6F, $4D70, $4D71, $4D72, $4D84,
  $4D85, $4D86, $52B5, $52B6, $52B7, $52B8, $52B9, $52BA,
  $52BB, $52BC, $52BD,

  $4CCE, $4CCF, $4CD1, $4CD2, $4CD4, $4CD5, $4CD7, $4CD9,
  $4CDB, $4CDC, $4CDE, $4CDF, $4CE1, $4CE2, $4CE4, $4CE5,
  $4CE7, $4CE8, $4CF9, $4CFA, $4CFC, $4CFD, $4CFF, $4D00,
  $4D02, $4D03, $4D45, $4D46, $4D47, $4D48, $4D49, $4D4A,
  $4D4B, $4D4C, $4D4D, $4D4E, $4D4F, $4D50, $4D51, $4D52,
  $4D53, $4D5C, $4D5D, $4D5E, $4D5F, $4D60, $4D61, $4D62,
  $4D63, $4D64, $4D65, $4D66, $4D67, $4D68, $4D69, $4D73,
  $4D74, $4D75, $4D76, $4D77, $4D78, $4D79, $4D7A, $4D7B,
  $4D7C, $4D7D, $4D7E, $4D7F, $4D87, $4D88, $4D89, $4D8A,
  $4D8B, $4D8C, $4D8D, $4D8E, $4D8F, $4D90, $4D95, $4D96,
  $4D97, $4D99, $4D9A, $4D9B, $4D9D, $4D9E, $4D9F, $4DA1,
  $4DA2, $4DA3, $4DA5, $4DA6, $4DA7, $4DA9, $4DAA, $4DAB,
  $52BE, $52BF, $52C0, $52C1, $52C2, $52C3, $52C4, $52C5,
  $52C6, $52C7];
  CheckConnection;
  GetTilesToMine; 
  while(true) do begin
    CheckConnection;
    case state of
      0:begin
        TryHarvest;
      end;
      2:begin
        TryConvert;
      end;
    end;     
    hidden := false;
  end;
end.