//    :
// -      
// -      ,    
// -  
// - 
// -       - Spinning Wheel  Loom
//   
// -     
// -   ,      World,      ,         info
// -     ,      World,      ,         info
// -         16
// -       198,      
Program Cloth;
const unload_container = $40B02B6C;
const cotton_book = $4098F2F2;
const runes = 14;
const weight_threshold = 10;
book_gump = $554b87f3;

var
state, c: Integer; // 0 - init, 1 - harvest, 2 - convert
current_rune: Integer;
walking: BOolean;
p : TPathArray;
target: Cardinal;
found: Cardinal;
hidden:Boolean;

function WaitForGump(id:Cardinal): Integer;
var
attempts, i: Integer;
begin

  for attempts := 0 to 15 do begin
    AddToSystemJournal(' ...');
    wait(200);
    for i := 0 to GetGUmpsCount - 1 do begin
      if GetGumpID(i) = id then begin
        Result := i;
        Exit;
      end;
    end;
  end;
  Result := -1;
  AddToSystemJournal(' ' + IntTOStr(id) + '  !');
end;

procedure ReplyGump(id, btn: Cardinal);
var
i:Integer;
begin
  for i := 0 to GetGUmpsCount - 1 do begin
    if GetGumpID(i) = id then begin
      if NumGumpButton(i, btn) then begin
        Wait(500);
        break;
      end;
    end;
  end;
end;

procedure TryTeleport;
begin
  wait(8000);
  UseObject(cotton_book);
  wait(200);
  ReplyGump($554b87f3, 6 * (current_rune + 1) + 5);
  wait(2000);
  state := 1;
  if(current_rune + 2 > runes) then
  current_rune := 0;

  current_rune  := current_rune + 1;
end;

procedure TeleportHome;
begin
    AddToSystemJournal(' ...');

  wait(8000);
  UseObject(cotton_book);
  wait(200);
  ReplyGump($554b87f3,5);
  wait(2000);
end;

procedure CheckWool;
begin
  FindDIstance := 2;
  if(findtype($0DF9, Ground) <> 0) then begin
    MoveItem(finditem, findquantity, Backpack, 0,0,0);
    wait(100);
  end;
end;

procedure TryHarvest;
var
c: Integer;
begin
  if((Weight < MaxWeight - weight_threshold)) then begin
    if(not walking) then begin
      if(target = -1)then begin
        FindDistance := 25;
        if((findtype($0C51, Ground) <> 0)) then begin
          target := finditem;
        end else if(findtype($0C52, Ground) <> 0) then begin
          target := finditem;
        end else if(findtype($0C53, Ground) <> 0) then begin
          target := finditem;
        end else if(findtype($0C54, Ground) <> 0) then begin
          target := finditem;
        end else begin  
          AddToSystemJournal('    ...');
          TryTeleport;
        end;
      end;

      if((GetDistance(target) <= 1) and (target <> -1)) then begin  
        AddToSystemJournal('...');
        UseObject(target);
        wait(300);
        target := -1;
      end;
    end;
  end else begin
    AddToSystemJournal(' !');
    wait(6000);
    TeleportHome;
    state := 2;
  end;
end;

procedure TryConvert;
var
loom: Cardinal;
wheel: Cardinal;
scissors: Cardinal;
begin
  FindDistance := 25;    
  FindVertical := 10;     
  
  FindType($105F, Ground);
  loom := finditem;

  FindType($1015, Ground);
  wheel := finditem;   

  FindType($0F9F, Backpack);
  scissors := finditem;     
  
  if(GetDistance(unload_container) > 1) then begin 
    AddToJournal(' ...');
    target := unload_container;
  end else begin
    if(not walking) then begin
      if((FindType($0DF9, Backpack) = 0) and (FindType($0F95, Backpack) = 0) and (FindType($0FA0, Backpack) = 0)) then begin
        state := 0;    
        AddToJournal(' ...');
      end else begin
        if(FindType($0DF9, Backpack) <> 0) then begin
          UseObject(finditem);
          wait(600);
          TargetToObject(wheel);
        end;
        if(FindType($0FA0, Backpack) <> 0) then begin
          UseObject(finditem);
          wait(600);
          TargetToObject(loom);
        end;
        if(FindType($0F95, Backpack) <> 0) then begin
          UseObject(unload_container);
          wait(600);
          UseObject(scissors);
          wait(600);
          TargetToObject(finditem);
          wait(600);
          FindType($1766, Backpack);
          MoveItem(finditem, findquantity, unload_container, 0, 0, 0);
          wait(600);
        end;
      end;
    end;
  end;
  if(loom = 0) then begin
    TeleportHome;
  end;

end;

Function IsFriend(ID: Cardinal): Boolean;
Var
listFriends: array of Cardinal;
i: Integer;
Begin
  listFriends :=
[
  // ID    :
  Self,
  $0003DDD0,
  $00059a74,
  $0007818C,
  $00017FC7,
  $00024331,
  $00027F0E,
  $0007B49B,
  $000A775F
  ];
  for i := 0 to Length(listFriends) - 1 do
  if ID = listFriends[i] then
  begin
    Result := TRUE;
    EXIT;
  end;
  Result := FALSE;
End;

function isMonster(body:Cardinal):boolean;
var
bodies: Array of Cardinal;
i:Integer;
begin
  bodies := [$0003, $0032, $001A, $0018, $0016, $0009,  $00A2, $0012,
  $0035, $0011, $001C,$0023,  $0004 , $003A, $0024 , $0001, $000D];
  Result := false;
  for i := 0 to High(bodies) do begin
    if(bodies[i] = body) then begin
      Result := true;
      Exit;
    end;
  end;
end;

Function CheckOfDangerNEW(ID: Cardinal): Boolean;
Var
ccRec: TClilocRec;
typeObject: Word;
i, k: Integer;
Begin
  Result := FALSE;
  if IsFriend(ID) then EXIT;
  k := 0;
  while (k < 200) and (GetTooltip(ID) = '') do
  begin
    k := k + 1;
    Wait(10);
  end;
  if GetTooltip(ID) <> '' then
  begin
    ccRec := GetToolTipRec(ID);
    for i := 0 to ccRec.Count - 1 do
    begin
      if ccRec.Items[i].ClilocID = 1060660 then
      begin
        typeObject := GetType(ID);
        AddToSystemJournal('!   :');
        AddToSystemJournal('  Type: $' + IntToHex(typeObject, 4) +
        '  ID: $' + IntToHex(ID, 8) +
        '  Tooltip: ' + GetTooltip(ID));
        Result := TRUE;
        EXIT;
      end else if(isMonster(GetType(ID))) then begin
        AddToSystemJournal('!  :');
        AddToSystemJournal('  Type: $' + IntToHex(typeObject, 4) +
        '  ID: $' + IntToHex(ID, 8) +
        '  Tooltip: ' + GetTooltip(ID));
        Result := TRUE;
        EXIT;
      end;
    end;
  end;
End;

procedure CheckConnection;
begin
  if not Connected then begin
    while not Connected do begin 
      AddToSystemJournal('...');
      wait(10000);
      Connect;
    end; 
    Cast('Protection');
  end;
end;

function Recall(b:Cardinal; r: Integer; ByScroll: boolean):Byte;
var
x, y : Word;
i: Integer;
msgBlocked, msgRecharge, msgRecovered, msgYouMustWait, msgConcentration, msgOverWeigth, msgFAILS, msgALL: String;
cTime: TDateTime;
begin
  CheckConnection;

  msgRecharge      := 'This book needs time to recharge.';
  msgYouMustWait   := 'You must wait to perform another action.';
  msgBlocked       := 'That location is blocked.';
  msgRecovered     := 'You have not yet recovered from casting a spell.';
  msgConcentration := 'Your concentration is disturbed, thus ruining thy spell.';
  msgOverWeigth    := 'Thou art too encumbered to move.';
  msgFAILS := msgRecharge + '|' + msgYouMustWait + '|' + msgRecovered;
  AddToSystemJournal('...');

  cTime := Now;
  UseObject(b);
  wait(500);

  Step(1, true);
  WaitForGump(book_gump);

  x := GetX(SelfID);
  y := GetY(SelfID);

  if(ByScroll) then begin
    ReplyGump(book_gump, 6 * r + 2);
  end else begin
    ReplyGump(book_gump, 6 * r + 5);
  end;
  wait(200);
  for i := 0 to 6 do begin   
  CheckConnection;
    AddToSystemJournal(' ...');
    CheckConnection;
    wait(500);
    if(InJournalBetweenTimes(msgFAILS, cTime, Now) <> -1) then begin result := 1; break; end;
    if(InJournalBetweenTimes(msgBlocked, cTime, Now) <> -1) then begin result := 2; break; end;

    if (((GetX(SelfID) <> x) or (GetY(SelfID) <> y))) then begin
      AddToSystemJournal(' ');
      Result := 0;
      Exit;
    end;
  end;
  AddToSystemJournal(' ');
end;

procedure Evaquate;
var
sucess:Byte;
begin
  hidden := true;
  sucess := Recall(cotton_book, 0, false);
  while not (sucess = 0)
  do begin        
    CheckConnection;
    sucess := Recall(cotton_book, 0, false);
  end;
  wait(1000);
  UseSkill('Hiding');
  DIsconnect;
  Wait(5 * 60 * 1000);
  CheckConnection;
  state := 0;
end;

Procedure EventDrawObject(ID: Cardinal);
Begin
  if CheckOfDangerNEW(ID) and not hidden then Evaquate;
End;
  
begin
  SetEventProc(evDrawObject,'EventDrawObject');

  state := 0;
  current_rune := 0;
  walking := false;
  target := -1;

  while not dead do begin
    wait(10);

    while not Connected do begin Connect; wait(10000); end;

    CheckWool;

    if(target <> -1) then begin
      walking := true;
      if(GetDIstance(target) > 1) then begin
        c := GetPathArray(GetX(target), GetY(target), True, 1,  p);
        if c > 0 then StepQ(CalcDir(PredictedX, PredictedY, p[0].X, p[0].Y), True);
      end else begin
        walking := false;  
        target := -1;
      end;
    end else begin
      walking := false;
    end;
    case state of
      0:begin           
        AddToSystemJournal('  ...');
        TryTeleport;
      end;
      1:begin      
        TryHarvest;
      end;
      2:begin 
        AddToSystemJournal('...');
        TryConvert;
      end;
    end; 
      hidden := false;

  end;
end.