// Для работы скрипта необходимо:
// - магери, галеон
// - рунбука с руной в банк с названием 'stock'
// - лрк сет
// - руна на корабль
// - 12 ловушек на крабов
// - галеон должен стоять в глубоких водах, т.е. не у берега!
// Для настройки необходимо
// - указать серийник руны на корабль, это можно сделать через вкладку World, найдя там свою руну в списке, либо через запуск клиента через стелс и командой info
// - указать серийник контейнера банка, это можно сделать только через вкладку World, открыв банк и найдя в списке сундук
Program BankFisher;
const
rune = $40b9268f;
bank = $405F29D5;
home_book_name = 'stock';
weight_threshold = 50;
max_traps = 12;
traps_per_row = 6;

book_type = $22C5;
book_gump = $554B87F3;
trap_name = 'empty lobster trap';
var
start: TDateTime;
i: Integer;
fish: Array of Cardinal;
home_book: Cardinal;
SL: TStringList;
x, y, incr, traps: Integer;

procedure CheckConnection;
begin
  if not Connected then begin
    while not Connected do begin
      AddToSystemJournal('Reconnecting...');
      wait(10000);
      Connect;
    end;
  end;
end;


procedure CloseGump(id: Cardinal);
var
i:Integer;
begin
  for i := 0 to GetGUmpsCount - 1 do begin
    if GetGumpID(i) = id then begin
      CloseSimpleGUmp(i);
      Wait(500);
      break;
    end;
  end;
end;

function WaitForGump(id:Cardinal): Integer;
var
attempts, i: Integer;
begin

  for attempts := 0 to 15 do begin
    AddToSystemJournal('Ждем гамп...');
    wait(200);
    for i := 0 to GetGUmpsCount - 1 do begin
      if GetGumpID(i) = id then begin
        Result := i;
        Exit;
      end;
    end;
  end;
  Result := -1;
  AddToSystemJournal('Гамп ' + IntTOStr(id) + ' не найден!');
end;


procedure ReplyGump(id, btn: Cardinal);
var
i:Integer;
begin
  for i := 0 to GetGUmpsCount - 1 do begin
    if GetGumpID(i) = id then begin
      if NumGumpButton(i, btn) then begin
        Wait(500);
        break;
      end;
    end;
  end;
end;

function HasProperty(item:Cardinal; prop: String):boolean;
var
tooltip: String;
i:Integer;
begin
  SL := TStringList.Create;
  tooltip := GetTooltip(item);

  StrBreakApart(tooltip, '|', SL);
  Result := false;
  for i := 0 to Sl.Count -1 do begin
    if(BMSearch(0, Sl.Strings[i], prop) <> 0) then begin
      Result := true;
      break;
    end;
  end;
  SL.Free;
end;

procedure SetupBooks();
var
id: Cardinal;
List: TStringList;
i:Integer;
begin
  List := TStringList.Create;
  FIndType(book_type, Backpack);
  GetFIndedList(List);
  for i := 0 to List.Count - 1 do begin
    id := StrToInt('$'+List[i]);
    if(HasProperty(id, home_book_name)) then begin
      home_book := id;
    end;
  end;
  if(home_book = -1) then begin
    AddToSystemJournal('Нет рунбуки домой!');
  end else begin
    AddToSystemJournal('Рунбука домой есть');
  end;
end;


function Recall(b:Cardinal; r: Integer; ByScroll: boolean):Byte;
var
x, y : Word;
i: Integer;
msgBlocked, msgRecharge, msgRecovered, msgYouMustWait, msgConcentration, msgOverWeigth, msgFAILS, msgALL: String;
cTime: TDateTime;
begin
  CheckConnection;

  msgRecharge      := 'This book needs time to recharge.';
  msgYouMustWait   := 'You must wait to perform another action.';
  msgBlocked       := 'That location is blocked.';
  msgRecovered     := 'You have not yet recovered from casting a spell.';
  msgConcentration := 'Your concentration is disturbed, thus ruining thy spell.';
  msgOverWeigth    := 'Thou art too encumbered to move.';
  msgFAILS := msgRecharge + '|' + msgYouMustWait + '|' + msgRecovered + '|' + 'reagents';
  AddToSystemJournal('Телепортация...');

  cTime := Now;
  UseObject(b);
  wait(500);

  Step(1, true);
  WaitForGump(book_gump);

  x := GetX(SelfID);
  y := GetY(SelfID);

  if(ByScroll) then begin
    ReplyGump(book_gump, 6 * r + 2);
  end else begin
    ReplyGump(book_gump, 6 * r + 5);
  end;
  wait(500);
  for i := 0 to 6 do begin
    AddToSystemJournal('Проверка телепортации...');
    CheckConnection;
    wait(500);
    if(InJournalBetweenTimes(msgFAILS, cTime, Now) <> -1) then begin result := 1; break; end;
    if(InJournalBetweenTimes(msgBlocked, cTime, Now) <> -1) then begin result := 2; break; end;

    if (((GetX(SelfID) <> x) or (GetY(SelfID) <> y))) then begin
      AddToSystemJournal('Телепорт удачный');
      Result := 0;
      Exit;
    end;
  end;
  AddToSystemJournal('Телепорт НЕудачный');
end;

function HasResources():Boolean;
var
i:Integer;
begin
  for i := 0 to Length(fish) -1 do begin
    if(FIndType(fish[i], Backpack) <> 0) then begin
      Result := true;
      Exit
    end;
  end;
  Result := false;
end;

function Overloaded(): BOolean;
begin
  Result := (Weight > MaxWeight - weight_threshold);
end;

function HasTrapsDeployed(): BOolean;
begin
  FindDistance:=5; FindVertical:=10;
  FindType( $44CB, Ground);
  Result := false;
  if(FindFullQuantity() > 0) then begin
    Result := true;
  end;
end;


procedure GatherAll();
var
i :Integer;
begin
  FindDistance:=5; FindVertical:=10;
  while(HasTrapsDeployed) do begin
    if(FindType( $44CB, Ground) <> 0) then begin
      UseObject(finditem);
      wait(499);
      UseObject(finditem);
    end;
  end;
end;

function GetTotalTraps(): Integer;
begin
  FindDistance:=15; FindVertical:=255;
  FindType($44CB, Ground);
  Result := FindFullQuantity();
end;

procedure CheckTraps();
var
offset, xmpd: Integer;
begin
  FindDistance:=5; FindVertical:=10;
  if(GetTotalTraps() < max_traps) then begin
    if(FindType($44CF, Backpack) > 0) then begin
      UseObject(finditem);
      waitForTarget(500);
      CancelTarget;
      UseObject(finditem);
      waitForTarget(15000);
      offset := 2;
      xmpd := 1;
      if(incr >= max_traps / 2) then begin
        offset := 4; 
        TargetToXYZ(GetX(Self) + (incr - max_traps / 2)* 2 - 4, GetY(Self) + offset, -5);
      end else
      begin
        offset := 2; 
        TargetToXYZ(GetX(Self) + incr * 2 - 4, GetY(Self) + offset, -5);
      end;
      incr := incr + 1;

      if(incr >= max_traps) then begin
        incr := 0;
      end;
    end else if(FindType($44D0, Backpack) > 0) then begin
      UseObject(finditem);
      waitForTarget(500);
      CancelTarget;
      UseObject(finditem);
      waitForTarget(15000);
      offset := 2;
      xmpd := 1;
      if(incr >= max_traps / 2) then begin
        offset := 4; 
        TargetToXYZ(GetX(Self) + (incr - max_traps / 2)* 2 - 4, GetY(Self) + offset, -5);
      end else
      begin
        offset := 2; 
        TargetToXYZ(GetX(Self) + incr * 2 - 4, GetY(Self) + offset, -5);
      end;  
      incr := incr + 1;
      if(incr >= max_traps) then begin
        incr := 0;
      end;
    end else begin
      AddToSystemJournal('NO TRAPS!');
    end;
  end;
end;

begin
  incr := 0;
  home_book := -1;
  wait(1000);
  x := GetX(Self);
  y := GetY(Self);
  while((GetX(Self)= x) AND (GetY(Self) = y)) do begin
    Cast('Recall');
    WaitForTarget(3000);
    TargetToObject(rune);
    wait(1500);
  end;
  Step(4, false);
  Step(4, false);
  SetupBooks();
  fish := [$44D1, $44D2, $44D3, $44D4];
  while(true) do begin
    wait(100);
    CheckCOnnection;
    if(Overloaded) then begin
      GatherAll();
      while(not (Recall(home_book, 0, false) = 0)) do begin
      end;
      wait(1000);
      UOSay('bank');
      for i := 0 to High(fish) do begin
        CheckCOnnection;
        while(FindType(fish[i], Backpack) <> 0) do begin
          MoveItem(finditem, FindQuantity(), bank, 0,0,0);
          wait(350);
        end;
      end;
      wait(1000);
      x := GetX(Self);
      y := GetY(Self);
      while((GetX(Self)= x) AND (GetY(Self) = y)) do begin
        Cast('Recall');
        WaitForTarget(3000);
        TargetToObject(rune);
        wait(1500);
      end;
      Step(4, false);
      Step(4, false);
    end else begin
      start := Now;
      CheckTraps();
      while(InJournal('**bob**') <> -1) do begin
        CheckCOnnection;
        SetJournalLine(LineIndex, 'handled');
        UseObject(LineID);
        wait(600);
        UseObject(LineID);
      end;
    end;
  end;
end.